# docsify-plugin-runkit

[![NPM](https://img.shields.io/npm/v/docsify-plugin-runkit.svg?style=flat-square)](https://www.npmjs.com/package/docsify-plugin-runkit)
[![GitHub Workflow Status (main)](https://img.shields.io/github/actions/workflow/status/jhildenbiddle/docsify-plugin-runkit/test.yml?branch=main&label=checks&style=flat-square)](https://github.com/jhildenbiddle/docsify-plugin-runkit/actions?query=branch%3Amain+)
[![Codacy grade](https://img.shields.io/codacy/grade/e9c2a9504211450ab39e0d72a1158a47.svg?style=flat-square)](https://app.codacy.com/gh/jhildenbiddle/docsify-plugin-runkit/dashboard)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg?style=flat-square)](https://github.com/jhildenbiddle/docsify-plugin-runkit/blob/main/LICENSE)
[![jsDelivr](https://data.jsdelivr.com/v1/package/npm/docsify-plugin-runkit/badge)](https://www.jsdelivr.com/package/npm/docsify-plugin-runkit)
[![Sponsor this project](https://img.shields.io/static/v1?style=flat-square&label=Sponsor&message=%E2%9D%A4&logo=GitHub&color=%23fe8e86)](https://github.com/sponsors/jhildenbiddle)

A [docsify.js](https://docsify.js.org) plugin for rendering interactive JavaScript <abbr title="Read-Eval-Print Loop">REPL</abbr>s powered by [RunKit](https://runkit.com/).

- [Documentation](https://jhildenbiddle.github.io/docsify-plugin-runkit)

**Screenshot**

<!-- Screenshots made with https://www.screely.com/ -->
<p>
  <a href="https://jhildenbiddle.github.io/docsify-plugin-runkit">
    <picture>
      <source srcset="https://raw.githubusercontent.com/jhildenbiddle/docsify-plugin-runkit/main/docs/assets/img/screenshot-runkit.webp" type="image/webp">
      <img src="https://raw.githubusercontent.com/jhildenbiddle/docsify-plugin-runkit/main/docs/assets/img/screenshot-runkit.jpg" alt="screenshot">
    </picture>
  </a>
</p>

> 💡 Like this plugin? Check out [docsify-themeable](https://jhildenbiddle.github.io/docsify-themeable) for your site theme, [docsify-tabs](https://jhildenbiddle.github.io/docsify-tabs/) for tabbed content, and [docsify-plugin-ethicalads](https://jhildenbiddle.github.io/docsify-plugin-ethicalads/) for EthicalAds integration!

## Features

- Render JavaScript code blocks as interactive [Node.js](https://nodejs.org/en/) <abbr title="Read-Eval-Print Loop">REPL</abbr>s
- Embed existing notebooks from [runkit.com](https://runkit.com/)
- Configure <abbr title="Read-Eval-Print Loop">REPL</abbr>s globally or individually using [options](https://jhildenbiddle.github.io/docsify-plugin-runkit#options) from RunKit's API
- Save changes as new notebooks on [runkit.com](https://runkit.com/)

## Installation & Options

See the [documentation site](https://jhildenbiddle.github.io/docsify-plugin-runkit) for details.

## Sponsorship

A [sponsorship](https://github.com/sponsors/jhildenbiddle) is more than just a way to show appreciation for the open-source authors and projects we rely on; it can be the spark that ignites the next big idea, the inspiration to create something new, and the motivation to share so that others may benefit.

If you benefit from this project, please consider lending your support and encouraging future efforts by [becoming a sponsor](https://github.com/sponsors/jhildenbiddle).

Thank you! 🙏🏻

## Contact & Support

- Follow 👨🏻‍💻 **@jhildenbiddle** on [Twitter](https://twitter.com/jhildenbiddle) and [GitHub](https://github.com/jhildenbiddle) for announcements
- Create a 💬 [GitHub issue](https://github.com/jhildenbiddle/docsify-plugin-runkit/issues) for bug reports, feature requests, or questions
- Add a ⭐️ [star on GitHub](https://github.com/jhildenbiddle/docsify-plugin-runkit) and 🐦 [tweet](https://twitter.com/intent/tweet?url=https%3A%2F%2Fgithub.com%2Fjhildenbiddle%2Fdocsify-plugin-runkit&hashtags=docsify,developers,frontend,javascript) to promote the project
- Become a 💖 [sponsor](https://github.com/sponsors/jhildenbiddle) to support the project and future efforts

## License

This project is licensed under the [MIT license](https://github.com/jhildenbiddle/docsify-plugin-runkit/blob/main/LICENSE).

Copyright (c) John Hildenbiddle ([@jhildenbiddle](https://twitter.com/jhildenbiddle))
