/*!
 * docsify-plugin-runkit
 * v1.0.3
 * https://jhildenbiddle.github.io/docsify-plugin-runkit/
 * (c) 2022-2024 John Hildenbiddle
 * MIT license
 */
(function() {
    "use strict";
    var e = [], t = [];
    function n(n, r) {
        if (n && "undefined" != typeof document) {
            var a, s = !0 === r.prepend ? "prepend" : "append", d = !0 === r.singleTag, i = "string" == typeof r.container ? document.querySelector(r.container) : document.getElementsByTagName("head")[0];
            if (d) {
                var u = e.indexOf(i);
                -1 === u && (u = e.push(i) - 1, t[u] = {}), a = t[u] && t[u][s] ? t[u][s] : t[u][s] = c();
            } else a = c();
            65279 === n.charCodeAt(0) && (n = n.substring(1)), a.styleSheet ? a.styleSheet.cssText += n : a.appendChild(document.createTextNode(n));
        }
        function c() {
            var e = document.createElement("style");
            if (e.setAttribute("type", "text/css"), r.attributes) for (var t = Object.keys(r.attributes), n = 0; n < t.length; n++) e.setAttribute(t[n], r.attributes[t[n]]);
            var a = "prepend" === s ? "afterbegin" : "beforeend";
            return i.insertAdjacentElement(a, e), e;
        }
    }
    var css = "[data-runkit] {\n    min-height: 1em;\n    margin: 1em 0;\n}\n\n[data-runkit] pre {\n    display: none;\n}\n\n[data-runkit] iframe {\n    display: block;\n}\n\n[data-runkit*=\"//\"] iframe {\n    width: calc(100% + 100px) !important;\n    margin-left: -50px !important;\n}\n\n[data-runkit-error] {\n    min-height: 1.5em;\n}\n\n[data-runkit-error]::before {\n    content: attr(data-runkit-error);\n    display: block;\n    padding-left: 1.75em;\n    background-image: url(\"data:image/svg+xml,%3Csvg viewBox='0 0 602 146' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath fill='%23F55FA6' d='M152.647 91.115l-8.433-45.875a19.108 19.108 0 0 0-7.575-12.686c-.549-.405-1.136-.757-1.728-1.098L86.92 3.757C79.757-.399 73.155-.459 66.035 3.638L17.939 31.447a18.863 18.863 0 0 0-3.084 2.228c-3.353 2.985-5.59 7.062-6.231 11.565L.191 91.115a19.104 19.104 0 0 0 9.363 19.235l57.313 33.09a19.104 19.104 0 0 0 19.105 0l4.509-2.604 52.804-30.486a19.105 19.105 0 0 0 9.362-19.235'/%3E%3Cpath fill='%23FFF' d='M93.816 26.854L81.841 54.185c-.673 1.457-2.266 1.784-3.589 1.049L46.516 36.935c-2.114-1.266-1.648-4.445.784-4.903l43.711-9.031c2.185-.412 3.711 1.814 2.805 3.853'/%3E%3Cpath fill='%23DB4792' d='M78.223 137.086c-.559-1.439-.792-2.983-.792-4.526V83.944c0-8.423-8.592-13.364-8.592-13.364S28.81 47.186 20.084 42.2c-10.023-5.728-2.145-10.753-2.145-10.753a18.906 18.906 0 0 0-3.084 2.228c-3.353 2.985-5.59 7.062-6.231 11.565L.191 91.115a19.104 19.104 0 0 0 9.363 19.235l57.313 33.09a19.104 19.104 0 0 0 19.105 0l4.509-2.604c-7.873 3.334-11.017-.55-12.258-3.75'/%3E%3C/svg%3E%0A\");\n    background-position: left 0.25em;\n    background-repeat: no-repeat;\n    background-size: auto 1.25em;\n}\n";
    n(css, {});
    var defaults = {
        nodeVersion: "18",
        gutterStyle: "inside"
    };
    function addEvents() {
        window.addEventListener("message", (function(e) {
            if (e.origin !== "https://runkit.com") {
                return;
            }
            var data;
            try {
                data = JSON.parse(e.data);
            } catch (e) {
                return false;
            }
            if (data.context !== "iframe.resize") {
                return false;
            }
            var iframe = document.querySelector('iframe[src="' + data.src + '"]');
            if (!iframe) {
                return false;
            }
            if (data.height) {
                iframe.height = data.height;
            }
        }));
    }
    function renderRunkitElms() {
        var runkitElms = [].slice.call(document.querySelectorAll("[data-runkit]"));
        runkitElms.forEach((function(runkitElm) {
            var notebookURL = runkitElm.getAttribute("data-runkit");
            if (notebookURL) {
                var baseURL = "https://embed.runkit.com/oembed?url=";
                var embedURL = baseURL + notebookURL;
                var xhr = new XMLHttpRequest;
                xhr.onreadystatechange = function() {
                    if (this.readyState === 4) {
                        if (this.status === 200) {
                            try {
                                var data = JSON.parse(xhr.responseText);
                                runkitElm.insertAdjacentHTML("afterbegin", data.html);
                            } catch (e) {
                                runkitElm.setAttribute("data-runkit-error", "Unable to parse response from ".concat(embedURL));
                            }
                        } else {
                            runkitElm.setAttribute("data-runkit-error", "".concat(xhr.status, " ").concat(xhr.responseText, ": ").concat(embedURL));
                        }
                    }
                };
                xhr.open("GET", embedURL, true);
                xhr.send();
            } else {
                var attrNames = runkitElm.getAttributeNames();
                var codeElm = runkitElm.querySelector("pre[data-lang] code");
                var sourceCode = codeElm ? codeElm.textContent : "";
                var notebookConfig = Object.assign({}, defaults, $docsify.runkit || {}, {
                    element: runkitElm,
                    source: sourceCode
                });
                attrNames.forEach((function(attr) {
                    var val = (runkitElm.getAttribute(attr) || "").trim();
                    if (val) {
                        var prop = (attr.match(/data-runkit-(\S*)/) || [])[1];
                        prop = prop.replace(/-([a-z])/g, (function(m) {
                            return m[1].toUpperCase();
                        }));
                        if (prop === "nodeVersion") {
                            val = typeof val === "number" ? String(val) : val;
                        } else if (val === "true" || val === "false") {
                            val = val === "true";
                        } else if (/^[{[][\s\S]*[}\]]$/.test(val)) {
                            val = JSON.parse(val);
                        } else if (!isNaN(val)) {
                            val = Number(val);
                        }
                        notebookConfig[prop] = val;
                    }
                }));
                RunKit.createNotebook(notebookConfig);
            }
        }));
    }
    function waitFor(options) {
        var defaults = {
            testFn: false,
            successFn: Function.prototype,
            failFn: Function.prototype,
            interval: 500,
            timeout: 2500
        };
        var settings = Object.assign({}, defaults, options);
        if (settings.testFn()) {
            settings.successFn();
        } else {
            var elapsed = 0;
            var waitInterval = setInterval((function() {
                if (elapsed >= settings.timeout) {
                    clearInterval(waitInterval);
                    settings.failFn();
                }
                if (settings.testFn()) {
                    clearInterval(waitInterval);
                    settings.successFn();
                } else {
                    elapsed += settings.interval;
                }
            }), settings.interval);
        }
    }
    (function() {
        var docsifyRunKit = function docsifyRunKit(hook, vm) {
            hook.init((function() {
                addEvents();
            }));
            hook.doneEach((function() {
                waitFor({
                    testFn: function testFn() {
                        return window.RunKit;
                    },
                    failFn: function failFn() {
                        console.warn("docsify-plugin-runkit: RunKit not available");
                    },
                    successFn: renderRunkitElms
                });
            }));
        };
        var scriptElm = document.createElement("script");
        scriptElm.src = "https://embed.runkit.com";
        document.body.appendChild(scriptElm);
        window.$docsify = window.$docsify || {};
        window.$docsify.plugins = [].concat(docsifyRunKit, window.$docsify.plugins || []);
    })();
})();
//# sourceMappingURL=docsify-plugin-runkit.js.map
