/*!
 * docsify-plugin-runkit
 * v1.0.3
 * https://jhildenbiddle.github.io/docsify-plugin-runkit/
 * (c) 2022-2024 John Hildenbiddle
 * MIT license
 */
!function(){"use strict";var t=[],e=[];!function(n,r){if(n&&"undefined"!=typeof document){var a,i=!0===r.prepend?"prepend":"append",o=!0===r.singleTag,c="string"==typeof r.container?document.querySelector(r.container):document.getElementsByTagName("head")[0];if(o){var s=t.indexOf(c);-1===s&&(s=t.push(c)-1,e[s]={}),a=e[s]&&e[s][i]?e[s][i]:e[s][i]=u()}else a=u();65279===n.charCodeAt(0)&&(n=n.substring(1)),a.styleSheet?a.styleSheet.cssText+=n:a.appendChild(document.createTextNode(n))}function u(){var t=document.createElement("style");if(t.setAttribute("type","text/css"),r.attributes)for(var e=Object.keys(r.attributes),n=0;n<e.length;n++)t.setAttribute(e[n],r.attributes[e[n]]);var a="prepend"===i?"afterbegin":"beforeend";return c.insertAdjacentElement(a,t),t}}("[data-runkit] {\n    min-height: 1em;\n    margin: 1em 0;\n}\n\n[data-runkit] pre {\n    display: none;\n}\n\n[data-runkit] iframe {\n    display: block;\n}\n\n[data-runkit*=\"//\"] iframe {\n    width: calc(100% + 100px) !important;\n    margin-left: -50px !important;\n}\n\n[data-runkit-error] {\n    min-height: 1.5em;\n}\n\n[data-runkit-error]::before {\n    content: attr(data-runkit-error);\n    display: block;\n    padding-left: 1.75em;\n    background-image: url(\"data:image/svg+xml,%3Csvg viewBox='0 0 602 146' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath fill='%23F55FA6' d='M152.647 91.115l-8.433-45.875a19.108 19.108 0 0 0-7.575-12.686c-.549-.405-1.136-.757-1.728-1.098L86.92 3.757C79.757-.399 73.155-.459 66.035 3.638L17.939 31.447a18.863 18.863 0 0 0-3.084 2.228c-3.353 2.985-5.59 7.062-6.231 11.565L.191 91.115a19.104 19.104 0 0 0 9.363 19.235l57.313 33.09a19.104 19.104 0 0 0 19.105 0l4.509-2.604 52.804-30.486a19.105 19.105 0 0 0 9.362-19.235'/%3E%3Cpath fill='%23FFF' d='M93.816 26.854L81.841 54.185c-.673 1.457-2.266 1.784-3.589 1.049L46.516 36.935c-2.114-1.266-1.648-4.445.784-4.903l43.711-9.031c2.185-.412 3.711 1.814 2.805 3.853'/%3E%3Cpath fill='%23DB4792' d='M78.223 137.086c-.559-1.439-.792-2.983-.792-4.526V83.944c0-8.423-8.592-13.364-8.592-13.364S28.81 47.186 20.084 42.2c-10.023-5.728-2.145-10.753-2.145-10.753a18.906 18.906 0 0 0-3.084 2.228c-3.353 2.985-5.59 7.062-6.231 11.565L.191 91.115a19.104 19.104 0 0 0 9.363 19.235l57.313 33.09a19.104 19.104 0 0 0 19.105 0l4.509-2.604c-7.873 3.334-11.017-.55-12.258-3.75'/%3E%3C/svg%3E%0A\");\n    background-position: left 0.25em;\n    background-repeat: no-repeat;\n    background-size: auto 1.25em;\n}\n",{});var n,r={nodeVersion:"18",gutterStyle:"inside"};function a(){[].slice.call(document.querySelectorAll("[data-runkit]")).forEach((function(t){var e=t.getAttribute("data-runkit");if(e){var n="https://embed.runkit.com/oembed?url="+e,a=new XMLHttpRequest;a.onreadystatechange=function(){if(4===this.readyState)if(200===this.status)try{var e=JSON.parse(a.responseText);t.insertAdjacentHTML("afterbegin",e.html)}catch(e){t.setAttribute("data-runkit-error","Unable to parse response from ".concat(n))}else t.setAttribute("data-runkit-error","".concat(a.status," ").concat(a.responseText,": ").concat(n))},a.open("GET",n,!0),a.send()}else{var i=t.getAttributeNames(),o=t.querySelector("pre[data-lang] code"),c=o?o.textContent:"",s=Object.assign({},r,$docsify.runkit||{},{element:t,source:c});i.forEach((function(e){var n=(t.getAttribute(e)||"").trim();if(n){var r=(e.match(/data-runkit-(\S*)/)||[])[1];"nodeVersion"===(r=r.replace(/-([a-z])/g,(function(t){return t[1].toUpperCase()})))?n="number"==typeof n?String(n):n:"true"===n||"false"===n?n="true"===n:/^[{[][\s\S]*[}\]]$/.test(n)?n=JSON.parse(n):isNaN(n)||(n=Number(n)),s[r]=n}})),RunKit.createNotebook(s)}}))}(n=document.createElement("script")).src="https://embed.runkit.com",document.body.appendChild(n),window.$docsify=window.$docsify||{},window.$docsify.plugins=[].concat((function(t,e){t.init((function(){window.addEventListener("message",(function(t){if("https://runkit.com"===t.origin){var e;try{e=JSON.parse(t.data)}catch(t){return!1}if("iframe.resize"!==e.context)return!1;var n=document.querySelector('iframe[src="'+e.src+'"]');if(!n)return!1;e.height&&(n.height=e.height)}}))})),t.doneEach((function(){!function(t){var e={testFn:!1,successFn:Function.prototype,failFn:Function.prototype,interval:500,timeout:2500},n=Object.assign({},e,t);if(n.testFn())n.successFn();else var r=0,a=setInterval((function(){r>=n.timeout&&(clearInterval(a),n.failFn()),n.testFn()?(clearInterval(a),n.successFn()):r+=n.interval}),n.interval)}({testFn:function(){return window.RunKit},failFn:function(){console.warn("docsify-plugin-runkit: RunKit not available")},successFn:a})}))}),window.$docsify.plugins||[])}();
//# sourceMappingURL=docsify-plugin-runkit.min.js.map
